<?php
/*
Plugin Name:WPSC Members and Capabilities
Plugin URI: http://www.instinct.co.nz
Description: A module that allows buying capabilities
Version: 2.0
Author: Instinct Entertainment
Author URI:  http://getshopped.org/extend/premium-upgrades/premium-upgrades/members-only-module/
*/

//Define the URL to the plugin folder
$wpsc_plugin_url = plugins_url('',__FILE__);
define('WPSC_MEMBERS_FOLDER', dirname(plugin_basename(__FILE__)));
define('WPSC_MEMBERS_URL', $wpsc_plugin_url.'/plugins/'.WPSC_MEMBERS_FOLDER);
include('widgets/my-subscriptions.php');

// edit this line to add your bbpress prefix
define("WPSC_BB_PREFIX", "bb_");


	add_action('admin_init', 'vl_wpscsm_admin_init');
	
	/**
	 * The init function for this plugin
	 * @access to admins
	 *
	 * @since 0.2
	 */
	function vl_wpscsm_admin_init() {
		/* Do something */
	}
	


	//Set default capabilities if the option is empty
	$wpsc_product_capability_list = get_option('wpsc_product_capability_list');
	if(empty($wpsc_product_capability_list) || (count($wpsc_product_capability_list) < 1)) {
		$wpsc_product_capability_list = array(
			'posts-base' => array(
				'name' => __('Basic Membership Access','wpsc'),
				'capability-type' => "wordpress",
				'subscription-length' => "wordpress"
			),
			'posts-premium' => array(
				'name' => __('Premium Membership Access','wpsc'),
				'capability-type' => "wordpress",
				'subscription-length' => "wordpress"
			),
		/*
	'forums-premium' => array(
				'name' => __('Premium Forums Access','wpsc'),
				'capability-type' => "bbpress"
			)
*/
		);
		update_option('wpsc_product_capability_list', $wpsc_product_capability_list);
	}
	
		
	function wpsc_purch_cap_product_forms($product_data='') {
		global $closed_postboxes, $wpsc_product_capability_list;
		$siteurl = get_option('siteurl');
		$output='';
		$meta_value='';
		if ($product_data == 'empty') {
			$display = "style='display:none;'";
		}
		if((float)WPSC_VERSION < 3.8 ){
		$meta_value = 'productmeta_values';
		?>
		
		<div id='wpsc_purch_cap_product_forms' class='postbox <?php echo ((array_search('wpsc_purch_cap_product_forms', (array)$product_data['closed_postboxes']) !== false) ? 'closed' : '');	?>' <?php echo ((array_search('wpsc_purch_cap_product_forms', (array)$product_data['hidden_postboxes']) !== false) ? 'style="display: none;"' : ''); ?>>
			<h3 class='hndle'><?php _e("Membership Control",'wpsc'); ?></h3>
			<div class='inside'>
			 <?php } else {
			$product_data = get_post($product_data->ID, ARRAY_A);
			$meta_value = 'meta';
			$product_data['id'] = $product_data['ID'];

		} 

		$saved_product_capabilties = (array)get_product_meta($product_data['id'],'product-capabilities',true);
		$saved_membership_length = (array)get_product_meta($product_data['id'],'membership_length',true);
		$is_recurring = (array)get_product_meta($product_data['id'],'is_recurring',true);
		$is_permanent = (array)get_product_meta($product_data['id'],'is_permanent',true); 
		$number_times_rebill = (array)get_product_meta($product_data['id'],'rebill_number',true);
		$rebill_period = (array)get_product_meta($product_data['id'],'rebill_interval',true);
		echo '<pre>'.print_r($rebill_period['number'],1).'</pre>';
			?> <div>
			  <strong><?php _e("This product allows buyers to view pages and posts that have been associated with the following capabilities:",'wpsc'); ?></strong>
				<?php
				foreach($wpsc_product_capability_list as $product_capability => $product_capability_data) {
				  $is_checked = '';
				  if(array_search($product_capability, $saved_product_capabilties) !== false) {
						$is_checked = "checked='checked'";
				  }
					?>
					<div>
						<label>
						<input type="checkbox" <?php echo $is_checked; ?> name= "<?php echo $meta_value; ?>[_wpsc_product-capabilities][]"  value="<?php echo $product_capability; ?>" />
						<?php echo $product_capability_data['name']; ?>
						</label>
					</div>
					<?php
				}
				?>
				<p><?php _e('Please note, you must ensure that the corresponding pages and posts also have these capabilities checked'); ?></p>
				</div>
				
				<br />
	
	
	<?php //exit('Permanent?:<pre>'.print_r($is_permanent,true).'</pre>'); ?>
				<div>
				<label for="wpsc_membership_length">Membership Length</label>
				<input id="wpsc_membership_length" size="3" name="<?php echo $meta_value; ?>[_wpsc_membership_length][length]" value="<?php echo $saved_membership_length['length']; ?>" type="text">
				
				<select name="<?php echo $meta_value; ?>[_wpsc_membership_length][unit]">
					<option <?php if($saved_membership_length['unit'] == 'd'){echo 'selected="selected"';} ?> value="d">Days</option>
					<option <?php if($saved_membership_length['unit'] == 'w'){echo 'selected="selected"';} ?> value="w">Weeks</option>
					<option <?php if($saved_membership_length['unit'] == 'm'){echo 'selected="selected"';} ?> value="m">Months</option>
					<option  <?php if($saved_membership_length['unit'] == 'Y'){echo 'selected="selected"';} ?> value="Y">Years</option>
				</select>
				or <input type='hidden' value='0' name="<?php echo $meta_value; ?>[_wpsc_is_permanent]" /><input <?php if($is_permanent[0] == 1){echo 'checked="checked"';} ?> type="checkbox" value="1" name="<?php echo $meta_value; ?>[_wpsc_is_permanent]" id="wpsc_product_sub_type"/> Membership lasts forever
				</div>
	
	          
				<br />
				<br />
	
				
				<div>
					<?php _e("Does this product use recurring billing:",'wpsc'); ?>
					<div>
						<label>	<input <?php if($is_recurring){echo 'checked="checked"';} ?> type='radio' name='<?php echo $meta_value; ?>[_wpsc_is_recurring]' value='1' /> <?php _e("Yes",'wpsc'); ?></label>
						<label>	<input <?php if(!$is_recurring){echo 'checked="checked"';} ?> type='radio' name='<?php echo $meta_value; ?>[_wpsc_is_recurring]' value='0' /> <?php _e("No",'wpsc'); ?></label>
					</div>
				</div>
				<br />
	
				<div>
					<label><?php _e("Charge users credit card",'wpsc'); ?></label>
					<?php _e("every",'wpsc'); ?><input type='text' name ='<?php echo $meta_value; ?>[_wpsc_rebill_interval][number]' value='<?php echo $rebill_period['number'] ?>' size='3' />
					<select name='<?php echo $meta_value; ?>[_wpsc_rebill_interval][unit]'>
						<option <?php if($rebill_period['unit'] == 'week'){echo 'selected="selected"';} ?> value='week'><?php _e("Weeks",'wpsc'); ?></option>
						<option <?php if($rebill_period['unit'] == 'month'){echo 'selected="selected"';} ?> value='month'><?php _e("Months",'wpsc'); ?></option>
						<option <?php if($rebill_period['unit'] == 'year'){echo 'selected="selected"';} ?> value='year'><?php _e("Years",'wpsc'); ?></option>
					</select>
				</div>
					
				<br />
				
				<div>
					<?php /* <strong><?php _e("Select the Recurring Billing Settings",'wpsc'); ?></strong> */ ?>
					
					<div>
						<?php _e("Keep charging the users credit card until it expires:",'wpsc'); ?><br />
						<label>	<input type='radio' name='<?php echo $meta_value; ?>[_wpsc_charge_to_expiry]' value='1' checked='checked' /> <?php _e("Yes",'wpsc'); ?></label>
						<label>	<input type='radio' name='<?php echo $meta_value; ?>[_wpsc_charge_to_expiry]' value='0' /> <?php _e("No",'wpsc'); ?></label>
					</div>
	
					
					<div>
						<label><?php _e("Number of times to charge users credit card:",'wpsc'); ?><input type='text' name ='<?php echo $meta_value; ?>[_wpsc_rebill_number]' value='<?php echo $number_times_rebill[0] ?>' size='3' /></label>
					</div>
	
				<br />
					<div>
						<label><input type='checkbox' name='<?php echo $meta_value; ?>[_wpsc_email_on_subscription_end]' /><?php _e("Email customer when subscription ends",'wpsc'); ?></label>
					</div>	
				<br />
				</div>
			<?php if((float)WPSC_VERSION < 3.8 ){?>	
			</div>
		</div>
		<?php }
	  //return $output;
	}
	


	



function wpsc_add_purch_cap_product_form($order) {
	if(array_search('wpsc_purch_cap_product_forms', $order) === false) {
		$order[] = 'wpsc_purch_cap_product_forms';
	}	
return $order;
}

function wpsc_new_meta_boxes() {
add_meta_box( 'wpsc_add_meta_product_form', 'Members and Capabilities', 'wpsc_purch_cap_product_forms', 'wpsc-product', 'normal', 'high' );
}
add_action( 'admin_menu', 'wpsc_new_meta_boxes' );
	
if( (float)WPSC_VERSION < 3.8 )
	add_filter('wpsc_products_page_forms', 'wpsc_purch_cap_product_forms');

	function wpsc_add_caps_to_user($purchase_data) {
		global $wpdb, $wpsc_product_capability_list;
		extract($purchase_data);
		$existing_defined_capabilities = array_keys($wpsc_product_capability_list);
		// Only add capabilities to aaccepted orders
		if(($purchase_log['processed'] >= 2)) {
			$saved_product_capabilties = get_product_meta($cart_item['prodid'],'product-capabilities',true);
			$membership_length = (array)get_product_meta($cart_item['prodid'],'membership_length',true);
			$is_permanent = (int)get_product_meta($cart_item['prodid'],'is_permanent',true);
			$edit_user = new WP_User($purchase_log['user_ID']);
			
			$members_lengths = get_user_meta($edit_user->ID, '_subscription_ends');
			$members_starts = get_user_meta($edit_user->ID, '_subscription_starts');
			
			if(is_array($members_lengths) && !empty($members_lengths[0])){
			$members_lengths = $members_lengths[0];
			}
			if(is_array($members_starts) && !empty($members_starts[0])){
			$members_starts = $members_starts[0];
			}			
			
			foreach((array)$saved_product_capabilties as $saved_product_capability) {
				if(array_search($saved_product_capability, $existing_defined_capabilities) !== false) {
					switch($wpsc_product_capability_list[$saved_product_capability]['capability-type']) {
						case 'bbpress':
							wpsc_add_bb_capability($purchase_log['user_ID'], $saved_product_capability);
						break;
	
						case 'wordpress':
						default:
						//needs to save timestamp and check the validation has not expired
							// if the product is a permanent subscription, make the duration permanent
							// otherwise save the expiration date in a usermeta row called 'subcription_ends' 
							if($is_permanent ){
								$members_lengths[$saved_product_capability] = 'never';
							}else{
								switch($membership_length['unit']) {
						          case 'd':
						          $future_time = mktime(date('h'),date('m'),date('s'),date('m'),(date('d')+$membership_length['length']),date('Y'));
						          break;
						          case 'm':
						          $future_time = mktime(date('h'),date('m'),date('s'),(date('m')+$membership_length['length']),date('d'),date('Y'));
						          break;
						          case 'Y':
						          $future_time = mktime(date('h'),date('m'),date('s'),date('m'),date('d'),(date('Y')+$membership_length['length']));
						          break;
						          case 'w':
						          $length = 7 * (int)$membership_length['length'];	
						          $future_time = mktime(date('h'),date('m'),date('s'),date('m'),(date('d')+$length),date('Y'));						          
						          break;
								  
					           }
								$members_lengths[$saved_product_capability]= $future_time;
								
							}
							$members_starts[$saved_product_capability]= time();
							$edit_user->add_cap($saved_product_capability, true);
						break;
					}
				}
			}
			
			
//			echo date('d M Y', $members_lengths['posts-gold']);
//			exit('<pre>'.print_r($members_lengths,true).'</pre>');
			
			//Save users subscription end times
			update_user_meta($edit_user->ID,'_subscription_ends', $members_lengths);
			update_user_meta($edit_user->ID,'_subscription_starts', $members_starts);
		}
	}
	
	
	
	function wpsc_post_required_capabilities() {
	  global $wpdb, $wpsc_product_capability_list, $post_ID;
	  $post_needed_capabilities = get_post_meta($post_ID, '_required_capabilities',true);
		?>
		<div id='postvisibility' class='postbox meta-box-sortables'>
			<h3><?php _e("Sold Capabilities needed to view this Post",'wpsc'); ?></h3>
		    <div class='inside'>
		    
				<input type="hidden" name="wpsc_post_capabilities_is_submitted"  value="true"/>
				<?php
					//echo "<pre>".print_r($post_needed_capabilities,true)."</pre>";
					foreach($wpsc_product_capability_list as $product_capability => $product_capability_data) {
					  if($product_capability_data['capability-type'] == 'wordpress') {
							$is_checked = '';
							if(array_search($product_capability, (array)$post_needed_capabilities) !== false) {
								$is_checked = "checked='checked'";
							}
							?>
							<div>
								<label>
								<input type="checkbox" <?php echo $is_checked; ?> name="wpsc_post_capabilities[]"  value="<?php echo $product_capability; ?>"/>
								<?php echo $product_capability_data['name']; ?>
								</label>
							</div>	
						<?php
					  }
					}
				?>
			</div>
			
		</div>
		<?php
	}


add_action( 'admin_footer', 'wpsc_meta_boxes' );
	add_action('edit_form_advanced','wpsc_post_required_capabilities');
	add_action('edit_page_form', 'wpsc_post_required_capabilities');
	
	
	function wpsc_save_post_required_capabilities($post_ID) {
	  global $wpdb;
	  if($_POST['wpsc_post_capabilities_is_submitted'] == 'true') {
			update_post_meta($post_ID, '_required_capabilities', (array)$_POST['wpsc_post_capabilities']);
	  }
	}
	
	add_action('wp_insert_post', 'wpsc_save_post_required_capabilities');
	
	function wpsc_restrict_post_access($post_array) {
	  global $wpdb,$gateway_checkout_form_fields, $userdata;
	  $siteurl = get_option('siteurl');
	  if(!current_user_can('administrator')) {
			foreach((array)$post_array as $key=>$post) {
				$required_capabilities = (array)get_post_meta($post->ID,'_required_capabilities', true);
				if(count($required_capabilities) > 0) {
					$post_access = true;
					$members_length = (array)get_user_meta($userdata->ID,'_subscription_ends');
					if(is_array($members_length) && !empty($members_length[0])){
						$members_length = $members_length[0];
					}

					foreach($required_capabilities as $capability ) {
						if($capability != null){
							if ((int)mktime() > (int)$members_length[$capability] && $members_length[$capability] != 'never' ){
								$post_access = false;
								break;					
							}
						}
					}
					if($post_access === false ) {
						$post_array[$key]->post_content = apply_filters( 'wpsc_post_insufficient_capabilities', $post_array[$key]->post_content, $post);
					}
				}
			}
		}
	  return $post_array;
	}
	
	add_action('the_posts','wpsc_restrict_post_access');
	
	
	function wpsc_insufficient_capability_messages($post_content, $post) {
	  global $wpdb,$gateway_checkout_form_fields, $user_ID, $userdata;
		
		$siteurl = get_option('siteurl');
	
		// 	$post_content .= "<pre>".print_r($user_ID,true)."</pre>";
		// 	$post_content .= "<pre>".print_r($userdata,true)."</pre>";
		$default_message = get_capability_error_message($post);
		
		
		if($user_ID > 0) {
			$post_content = __($default_message);
			//$post_content = wpsc_filter_preview_content($post_content);
		
		 } else {
			$post_content = __($default_message);
			// mostly standard wp login form, redirects back to the current page, needs the siteurl because of permalinks
			//exit('<pre>'.print_r($post_content,true).'</pre>');
			//$post_content = wpsc_filter_preview_content($post_content);
			//$post_content .= apply_filters('the_content', $post_content);
			$post_content .= "<div>";
			//$post_content .= "This page is for subscribers only, if you have a subscription please login below <br />";
			$post_content .= " <form name='loginform' id='loginform' action='".$siteurl."/wp-login.php' method='post' style='text-align: left;'>";
			$post_content .= "   <label>Username: <input type='text' name='log' id='log' value='' size='20' tabindex='1' /></label><br />";
			$post_content .= "   <label>Password: <input type='password' name='pwd' id='pwd' value='' size='20' tabindex='2' /></label>";
			$post_content .= "   <input type='submit' name='submit' id='submit' value='Login &raquo;' tabindex='4' />";
			$post_content .= "   <input type='hidden' name='redirect_to' value='".$post->guid."' />";
			$post_content .= " </form>";
			$post_content .= "</div>";
		}
	  return $post_content;
	}
	
	add_filter('wpsc_post_insufficient_capabilities', 'wpsc_insufficient_capability_messages', 10, 2);
	
	
	function wpsc_edit_purchasable_capabilities() {
	  global $wpdb, $wpsc_product_capability_list;
		check_admin_referer('edit-capability','wpsc-edit-capability');
	//exit('<pre>'.print_r($_POST,1).'</pre>');
		$submitted_capability_data = $_POST['capability_list'];
		//check user has filled out required info before saving
		if($_POST['page_action'] == 'add' && !empty( $_POST['capability_list']['new']['capability']) && !empty($_POST['capability_list']['new']['name']) ) {

				$new_capability = $submitted_capability_data['new']['capability'];
				$new_capability_item = array();
				$new_capability_item[$new_capability]['name'] = $submitted_capability_data['new']['name'];
				$new_capability_item[$new_capability]['capability-type'] = $submitted_capability_data['new']['capability-type'];
				$new_capability_item[$new_capability]['message-details'] = $submitted_capability_data['new']['message-details'];
				$wpsc_product_capability_list = array_merge($wpsc_product_capability_list, $new_capability_item);
			} else {
			  foreach($submitted_capability_data as $submitted_capability_key => $submitted_capability_item) {
					if(count($wpsc_product_capability_list[$submitted_capability_key]) < 2) {
						$wpsc_product_capability_list[$submitted_capability_key] = array();
					}
					$wpsc_product_capability_list[$submitted_capability_key]['name'] = $submitted_capability_data[$submitted_capability_key]['name'];
					$wpsc_product_capability_list[$submitted_capability_key]['capability-type'] = $submitted_capability_data[$submitted_capability_key]['capability-type'];
					$wpsc_product_capability_list[$submitted_capability_key]['message-details'] = $submitted_capability_data[$submitted_capability_key]['message-details'];
			  }
			}
			//echo "<pre>".print_r($wpsc_product_capability_list, true)."</pre>";
			update_option('wpsc_product_capability_list', $wpsc_product_capability_list);
	}
	
	if($_REQUEST['wpsc_admin_action'] == 'capability_action') {
		add_action('admin_init', 'wpsc_edit_purchasable_capabilities');
	}
	
	function wpsc_add_bb_capability($user_id, $capability = '') {
		if($capability != '' ) {
			$bbpress_roles = (array)get_usermeta( $user_id, WPSC_BB_PREFIX . 'capabilities' );
			if(in_array($capability, $bbpress_roles)) {
				$bbpress_roles[] = $capability;
				update_usermeta( $user_id, WPSC_BB_PREFIX . 'capabilities', $bbpress_roles );
			}
		}
	}
	
	require_once('purchase_capability_admin.php');
	add_action('wpsc_transaction_result_cart_item','wpsc_add_caps_to_user');

			
	function wpsc_capabilities_add_scripts(){
		wp_enqueue_script('wpsc_capabilities', WPSC_MEMBERS_URL.'/css-and-js/admin.js', array('jquery'), '1.0.3');
		wp_enqueue_style('wpsc_capabilities', WPSC_MEMBERS_URL.'/css-and-js/style.css');
	}
	

	
		
	function wpsc_manage_caps(){
	 global	$wpsc_product_capability_list;
	}
	
	if($_REQUEST['members_caps']=='true'){
		wpsc_manage_caps();
	}
	
	function get_capability_error_message($post)
	{
		global $user_ID , $userdata;	
		
		$default_message = 'This page is for subscribers only, ';
		$error_message = '';
		
		$required_capabilities = (array)get_post_meta($post->ID,'_required_capabilities', true);
		$capabilities = get_option('wpsc_product_capability_list');
		
		
		if($required_capabilities != NULL) {
			foreach($required_capabilities as $capability_slug) 
			{
				$error_message .= $capabilities[$capability_slug]['message-details'].' ';
			}
			
			$default_message = $error_message;
		}
		
		return $default_message ;
	}
	
	

?>
